      1 /**
      2  * @license
      3  * Copyright 2011 Dan Vanderkam (danvdk@gmail.com)
      4  * MIT-licenced: https://opensource.org/licenses/MIT
      5  */
      6
      7 /**
      8  * @fileoverview A wrapper around the Dygraph class which implements the
      9  * interface for a GViz (aka Google Visualization API) visualization.
     10  * It is designed to be a drop-in replacement for Google's AnnotatedTimeline,
     11  * so the documentation at
     12  * http://code.google.com/apis/chart/interactive/docs/gallery/annotatedtimeline.html
     13  * translates over directly.
     14  *
     15  * For a full demo, see:
     16  * - http://dygraphs.com/tests/gviz.html
     17  * - http://dygraphs.com/tests/annotation-gviz.html
     18  */
     19
     20 /*global Dygraph:false */
     21 "use strict";
     22
     23 import Dygraph from './dygraph';
     24
     25 /**
     26  * A wrapper around Dygraph that implements the gviz API.
     27  * @param {!HTMLDivElement} container The DOM object the visualization should
     28  *     live in.
     29  * @constructor
     30  */
     31 var GVizChart = function(container) {
     32   this.container = container;
     33 };
     34
     35 /**
     36  * @param {GVizDataTable} data
     37  * @param {Object.<*>} options
     38  */
     39 GVizChart.prototype.draw = function(data, options) {
     40   // Clear out any existing dygraph.
     41   // TODO(danvk): would it make more sense to simply redraw using the current
     42   // date_graph object?
     43   this.container.innerHTML = '';
     44   if (typeof(this.date_graph) != 'undefined') {
     45     this.date_graph.destroy();
     46   }
     47
     48   this.date_graph = new Dygraph(this.container, data, options);
     49 };
     50
     51 /**
     52  * Google charts compatible setSelection
     53  * Only row selection is supported, all points in the row will be highlighted
     54  * @param {Array.<{row:number}>} selection_array array of the selected cells
     55  * @public
     56  */
     57 GVizChart.prototype.setSelection = function(selection_array) {
     58   var row = false;
     59   if (selection_array.length) {
     60     row = selection_array[0].row;
     61   }
     62   this.date_graph.setSelection(row);
     63 };
     64
     65 /**
     66  * Google charts compatible getSelection implementation
     67  * @return {Array.<{row:number,column:number}>} array of the selected cells
     68  * @public
     69  */
     70 GVizChart.prototype.getSelection = function() {
     71   var selection = [];
     72
     73   var row = this.date_graph.getSelection();
     74
     75   if (row < 0) return selection;
     76
     77   var points = this.date_graph.layout_.points;
     78   for (var setIdx = 0; setIdx < points.length; ++setIdx) {
     79     selection.push({row: row, column: setIdx + 1});
     80   }
     81
     82   return selection;
     83 };
     84
     85 export default GVizChart;
     86